#! /bin/sh
#
# $Id: autogen.sh,v 1.4 2003/09/07 00:00:55 faugn Exp $

check_auto()
{
    echo -n 1>&2 "checking for $1 version >= $2.$3.$4 ..."
    required_version="`printf '%02d%02d%02d' "$2" "$3" "$4"`"
    found="$(echo "$PATH" | sed 's/^/ls -1 {/;s/:/,/g;s/$/}\/'"$1"'*/' |
    sh 2>/dev/null |
    while read prog
    do
	eval "`$prog --version |
	sed -n '1s/.*[[:space:]]\([0-9]\+\)\.\([0-9]\+\)\.\?\([0-9]*\).*/major=\1 minor=\2 patch=\3/p'`"
	test -z "$patch" && patch=0

	echo -n 1>&2 " $major.$minor.$patch"
	version="`printf '%02d%02d%02d' "$major" "$minor" "$patch"`"
	if test "$version" -ge "$required_version"
	then
	    echo "$prog"
	    exit 0
	fi
    done)"
    echo 1>&2
    if test -n "$found"
    then
	echo "$found"
	return 0
    fi
    echo 1>&2 "error: need $1 version $2.$3.$4 or above"
    echo 1>&2 "found : $found"
    return 1
}

AL="`check_auto aclocal    1  7 0`" || exit 1
AM="`check_auto automake   1  7 0`" || exit 1
AH="`check_auto autoheader 2 54 0`" || exit 1
AC="`check_auto autoconf   2 54 0`" || exit 1

set -x
"$AL" -I config/m4
"$AH"
"$AM" --add-missing --no-force --include-deps
"$AC"

# vim: shiftwidth=4
