#include "ka_logger.hh"

//{{{
void open_log() {
	ka_log = fopen(DEBUG_FILE_NAME, "w");
	if(!ka_log) {
		printf("Could not open log file %s", DEBUG_FILE_NAME);
		log_level = OFF;
	}
}
//}}}
//{{{
void log_info(char * fmt, ...) {
	if(log_level != OFF && (log_level >= INFO || log_level == INFO_ONLY)) {
		char * new_fmt = new char[strlen(INFO_PREFIX) + strlen(fmt) + 1];
		va_list ap;

		sprintf(new_fmt, "%s%s", INFO_PREFIX, fmt);

		va_start(ap, fmt);
		vfprintf(ka_log, new_fmt, ap);
		va_end(ap);
		fprintf(ka_log, "\n");
		fflush(ka_log);
	}
}
//}}}
//{{{
void log_debug(char * fmt, ...) {
	if(log_level != OFF && log_level >= DBG || log_level == DBG_ONLY) {
		char * new_fmt = new char[strlen(DBG_PREFIX) + strlen(fmt) + 1];
		va_list ap;

		sprintf(new_fmt, "%s%s", DBG_PREFIX, fmt);

		va_start(ap, fmt);
		vfprintf(ka_log, fmt, ap);
		va_end(ap);
		fprintf(ka_log, "\n");
		fflush(ka_log);
	}
}
//}}}
//{{{
void log_error(char * fmt, ...) {
	if(log_level != OFF && log_level >= ERROR || log_level == ERROR_ONLY) {
		char * new_fmt = new char[strlen(ERROR_PREFIX) + strlen(fmt) + 1];
		va_list ap;

		sprintf(new_fmt, "%s%s", ERROR_PREFIX, fmt);

		va_start(ap, fmt);
		vfprintf(ka_log, fmt, ap);
		va_end(ap);
		fprintf(ka_log, "\n");
		fflush(ka_log);
	}
}
//}}}
//{{{
void log_critical(char * fmt, ...) {
	if(log_level != OFF && log_level >= CRITICAL || log_level == CRITICAL_ONLY) {
		char * new_fmt = new char[strlen(CRITICAL_PREFIX) + strlen(fmt) + 1];
		va_list ap;

		sprintf(new_fmt, "%s%s", CRITICAL_PREFIX, fmt);

		va_start(ap, fmt);
		vfprintf(ka_log, fmt, ap);
		va_end(ap);
		fprintf(ka_log, "\n");
		fflush(ka_log);
	}
}
//}}}
//{{{
void close_log() {
	if(ka_log)
		fclose(ka_log);
}
//}}}
