/* file name  : ka_logger.hh
 * authors    : Michael Brailsford
 * created    : Mon Feb  2 00:03:59 2004
 * copyright  : Michael Brailsford
 * version    : $Revision: 1.2 $
 */

#ifndef KA_LOGGER_H
#define KA_LOGGER_H

#include <cstdio>
#include <cstdarg>
#include <cstring>

FILE * ka_log;

enum {
	//All the *_ONLY levels have to be less than OFF
	CRITICAL_ONLY,
	ERROR_ONLY,
	DBG_ONLY,
	INFO_ONLY,
	//OFF must be less that the cumulative levels
	OFF,
	//The cumulative levels must be greater than OFF
	//The log level that is most critical should be listed at the top of the list, and the least
	//critical should be at the bottom
	CRITICAL,
	ERROR,
	DBG,
	INFO
};

#define DEBUG_FILE_NAME		"~/.kahakai/rb_log"

#define INFO_PREFIX			"Info    :  "
#define DBG_PREFIX			"Debug   :  "
#define ERROR_PREFIX		"Error   :  "
#define CRITICAL_PREFIX		"Critical:  "

int log_level = OFF;

#ifdef DEBUG
log_level = INFO;
#endif

void open_log();
void close_log();

void log_info(char * fmt, ...);
void log_debug(char * fmt, ...);
void log_error(char * fmt, ...);
void log_critical(char * fmt, ...);

#endif


/*
 * change log
 *
 * $Log: ka_logger.hh,v $
 * Revision 1.2  2004/02/04 21:53:28  brailsmt
 * Ruby support is on the way.  This fixes a lot bugs and gets it to the point that actions that are
 * specified in config.rb are called at the right time, the downfall is that I get seg faults in
 * rb_funcall2 in swig-ruby.h:20.
 *
 * Revision 1.1  2004/02/03 20:36:50  brailsmt
 * printf() style logging functionality.
 *
 */

