# $Id: myconfig.py,v 1.5 2003/06/10 04:27:22 pervago Exp $

# Kahakai configuration file
from actions import *
from config  import Configuration, install


# If you want to extend the default functionality use the following:
#
#  def <functionName>(self):
#      return Configuration.<functionName>(self) + \
#             [... actions here ...]
#
# If you want to completely replace the default functionality use:
# 
#  def <functionName>(self):
#      return [ ... actions here ... ]
#
#

class MyConfiguration(Configuration):
    def globals(self):
        """Global settings which affect Kahakai behavior"""

        ## Focus & raise behavior:
        #
        #  mouseFocus()  - Focus follows mouse (both in & out the window)
        #                  Click to raise.
        #  sloppyFocus() - Like mouseFocus() but leaving window doesn't unfocus
        #  clickFocus()  - Windows-like behavior, click to focus & raise.
        
        sloppyFocus()
        focusNewWindows()

    def globalKeyBindings(self):
        """
        
        Place to define bindings (mostly keyboard) that apply to all
        parts of a window & the root window. Adding shortcuts for
        commonly used programs is a good use.

        Examples:

        ...
        [(KeyPress('XF86AudioPrev'), '{xmms -r}'),
         (KeyPress('Escape', 'Control_L'), ('RemapFocused', 'rootmenu'))
        ]
        """        
        return Configuration.globalKeyBindings(self) + \
               [(KeyPress('F7'), '{konsole}')]

install(MyConfiguration())
